<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="bg-light h-100 p-4">

  <!-- Header -->

  <app-breadcrumbs></app-breadcrumbs>

  <div class="d-flex w-100 pb-1">
    <div class="w-25">
      <div
        class="fw-bold mb-2"
        [innerText]="commonMessages.TENANT_LABEL">
      </div>
      <ng-select
        [(ngModel)]="selectedTenant"
        [compareWith]="compareByIdFn"
        (change)="refreshFolderList()"
        [notFoundText]="commonMessages.NO_TENANT_FOUND"
        [clearAllText]="commonMessages.CLEAR"
        [title]="commonMessages.TENANT_LABEL"
        id="type"
        class="mb-2"
        name="type"
        required>
        <ng-option
          *ngFor="let tenant of tenantList"
          [value]="tenant"
          [innerText]="tenant.name | namePipe">
        </ng-option>
      </ng-select>
    </div>

    <span class="flex-grow-1"></span>

    <div class="d-flex align-items-end">
      <span class="p-1 px-2" [innerText]="commonMessages.PAGINATION_SIZE_LABEL"></span>

      <ngb-pagination
        size="sm"
        class="me-2"
        [collectionSize]="pageSizes.length"
        [(page)]="pageSizeIndex"
        [pageSize]="1"
        [rotate]="false"
        [boundaryLinks]="false"
        [directionLinks]="false"
        (pageChange)="refreshFolderList()">
        <ng-template
          ngbPaginationNumber
          let-p>
          {{ getPageSize(p) }}
        </ng-template>
      </ngb-pagination>

      <fa-icon
        *ngIf="show52Features"
        [icon]="cogIcon"
        [ngbTooltip]="commonMessages.TABLE_LAYOUT_COG_TOOLTIP"
        (click)="openTableLayoutModal()"
        class="float-end pointer mt-1 mb-1 text-primary">
      </fa-icon>
    </div>

  </div>

  <!-- List -->

  <!-- The `aria-labelledby` does not have a label available, we go for the simple label -->
  <!-- eslint-disable-next-line -->
  <table
    [summary]="commonMessages.TRASH_BIN_NAME_PLURAL"
    *ngIf="userPreferences"
    class="bg-white table table-striped table-borderless border shadow-sm table-text-overflow table-fixed">
    <thead class="border">
      <tr>
        <ng-container *ngFor="let column of usedColumns">
          <th
            *ngIf="showIdColumn(column)"
            (click)="onRowOrderClicked(column)"
            [ngClass]="{
            'col-id-fixed-size' : column.id === columnsEnum.Id,
            'col-buttons-fixed-size' : column.id === columnsEnum.Actions,
            'col-3' : column.id === columnsEnum.Name || column === columnsEnum.TypeSubtype || column === columnsEnum.OriginDesk,
            'col-date-fixed-size' : column.id === columnsEnum.CreationDate,
            'pointer' : mapColumnToSortBy(column) !== null
          }">
            <fa-icon
              *ngIf="mapColumnToSortBy(column) !== null"
              class="{{ sortBy === mapColumnToSortBy(column) ? 'visible' : 'invisible' }}"
              [icon]="asc ? caretUp : caretDown"
              [fixedWidth]="true">
            </fa-icon>
            {{ column.type === columnTypeEnum.Metadata ? column.metadata?.name : column.id | columnNamePipe }}
          </th>
        </ng-container>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let folder of folderList">
        <td
          *ngFor="let column of usedColumns">
          <div *ngIf="column.id === columnsEnum.Id && showIdColumn(column)">
            <span
              class="sortable-row font-monospace text-size-small"
              [innerText]="folder.id | namePipe">
            </span>
          </div>
          <div
            *ngIf="column.id === columnsEnum.Name"
            class="sortable-row overflow-hidden text-overflow-ellipsis"
            [ngbTooltip]="folder.name | namePipe"
            [innerText]="folder.name | namePipe">
          </div>
          <div
            *ngIf="column.id === columnsEnum.TypeSubtype"
            [innerText]="folder.type?.name + ' / ' + folder.subtype?.name">
          </div>
          <div
            *ngIf="column.id === columnsEnum.CreationDate"
            class="sortable-row"
            [innerText]="folder.draftCreationDate | date: 'shortDate'">
          </div>
          <div
            *ngIf="column.id === columnsEnum.OriginDesk"
            [innerText]="folder.originDesk?.name">
          </div>
          <div *ngIf="column.id === columnsEnum.Actions" class="d-flex">
            <button
              type="button"
              class="btn btn-sm btn-outline-primary"
              [disabled]="!currentUserAdmin"
              [ngbTooltip]="commonMessages.DOWNLOAD"
              (click)="onDownloadButtonClicked(folder)">
              <fa-icon [icon]="downloadIcon"></fa-icon>
            </button>
            <div
              class="ms-2"
              [ngbTooltip]="currentUserAdmin ? commonMessages.DELETE : commonMessages.ADMIN_RIGHTS_REQUIRED_FOR_ACTION">
              <button
                type="button"
                class="btn btn-sm btn-outline-danger"
                [disabled]="!currentUserAdmin"
                (click)="onDeleteButtonClicked(folder)">
                <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
              </button>
            </div>
          </div>
          <div
            *ngIf="column.type === columnTypeEnum.Metadata && show52Features && column?.metadata?.key"
            [innerText]="folder.metadata[column.metadata.key] ?? ''">
          </div>
        </td>
      </tr>
    </tbody>
    <tbody
      app-list-loader
      [data]="folderList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_FOLDER_LIST">
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshFolderList()">
  </ngb-pagination>

</div>

